from django.apps import apps
from django.conf import settings
from django.urls import include, path
from django.views.decorators.cache import cache_page, never_cache

from common.views import ManifestView
from transport import views, views_app, views_stats

handler500 = 'common.views.error_view'

urlpatterns = [
    # Overrides url from benevole app:
    path('benevoles/transport/', views.ChauffeurListView.as_view(), {'app': 'transport'}, name='chauffeurs'),

    path('', include('common.urls')),
    path('', include('client.urls')),
    path('', include(f'{settings.CANTON_APP}.urls')),

    path('', views.AccueilTransportView.as_view(), name='home'),
    path('gestion/', views.GestionTransportView.as_view(), name='gestion'),
    path('gestion/statut<int:num>', views.GestionTransportView.as_view(), name='gestion-with-tab'),
    path('transports/statut<int:num>/', views.TransportByStatusView.as_view(), name='transports-by-status'),
    path('transports/statut<int:num>/<str:date>/', views.TransportByStatusView.as_view(),
        name='transports-by-status-and-day'),
    path('transports/jour/<int:year>/<int:month>/<int:day>/', views.TransportByDayView.as_view(),
        name='transports-by-day'),
    path('saisie/', views.TransportSaisieView.as_view(), name='transport-saisie'),
    path('transport/<int:pk>/edit/', views.TransportEditView.as_view(), name='transport-edit'),
    # Édition du modèle lui-même
    path('transport/modele/<int:pk>/edit/', views.TransportModelEditView.as_view(), name='transportmodel-edit'),
    # Édition d'une instance du modèle
    path('transport/<int:pk>/<int:moddate>/edit/', views.TransportEditView.as_view(),
        name='transport-model-edit'),
    path('transport/<int:pk>/cancel/', views.TransportCancelView.as_view(), name='transport-cancel'),
    path('transport/<int:pk>/<int:moddate>/cancel/', views.TransportCancelView.as_view(),
        name='transport-model-cancel'),
    path('transport/<int:pk>/attrib/', views.TransportAttribView.as_view(), name='transport-attrib'),
    path('transport/autoattrib/<int:year>/<int:month>/<int:day>/', views.TransportAutoAttribView.as_view(),
        name='transport-autoattrib'),
    path('transport/<int:pk>/<int:moddate>/attrib/', views.TransportAttribView.as_view(),
        name='transport-model-attrib'),
    path('transport/<int:pk>/attrib-remove/', views.TransportAttribRemoveView.as_view(),
        name='transport-attrib-remove'),
    path('transport/<int:pk>/refuse/', views.TransportRefuseView.as_view(), name='transport-refuse'),
    path('transport/confirm/', views.TransportConfirmView.as_view(), name='transport-confirm'),
    path('transport/<int:pk>/rapport/', views.TransportRapportView.as_view(), name='transport-rapport'),
    path('transport/<int:pk>/checked/', views.TransportCheckView.as_view(), name='transport-check'),
    path('calculer_heure_depart/', views.TransportCalculerDepart.as_view(), name='transport-calculer-depart'),
    path('transport/<int:pk>/trajets/', views.TrajetsDetailView.as_view(), name='trajets-details'),
    path('trajet/<int:pk>/set-distance/', views.TrajetSetDistanceView.as_view(fixed=False),
        name='trajet-set-distance'),
    path('trajet/<int:pk>/set-distance-fixed/', views.TrajetSetDistanceView.as_view(fixed=True),
        name='trajet-set-fixed-distance'),
    path('trajet/<int:pk>/aplusieurs/', views.TrajetAPlusieursView.as_view(), name='trajet-a-plusieurs'),

    path('clients/', views.ClientListView.as_view(), name='clients'),
    path('clients/archives/', views.ClientListView.as_view(is_archive=True), name='clients-archives'),
    path('clients/new/', views.ClientEditView.as_view(is_create=True), name='client-new'),
    path('clients/<int:pk>/edit/', views.ClientEditView.as_view(is_create=False), name='transport-client-edit'),
    path('clients/<int:pk>/details/', views.ClientDetailView.as_view(), name='transport-client-detail'),
    path('clients/<int:pk>/pref/new/', views.ClientPrefEditView.as_view(is_create=True),
        name='transport-client-newpref'),
    path('clients/<int:pk>/pref/<int:pk_pref>/edit/', views.ClientPrefEditView.as_view(is_create=False),
        name='transport-client-editpref'),
    path('clients/<int:pk>/transports/factures/', views.ClientListeFacturesView.as_view(),
        name='client-transports-factures'),
    path('clients/<int:pk>/transports/archives/', views.ClientTransportsView.as_view(passes=True),
        name='client-transports-archives'),
    path('clients/pref/<int:pk>/delete/', views.ClientPrefDeleteView.as_view(), name='transport-client-deletepref'),
    path('clients/derniers/', views.ClientDerniersTransportsView.as_view(), name='transport-client-derniers'),
    path('clients/adresse/', views.ClientAdresseJsonView.as_view(), name='client-address'),
    path('adresse/liste/', views.AdresseListeView.as_view(), name='transport-addresses'),
    path('adresse/new/', views.AdresseEditView.as_view(is_create=True), name='transport-address-add'),
    path('adresse/<int:pk>/edit/', views.AdresseEditView.as_view(is_create=False), name='transport-address-edit'),
    path('adresse/<int:pk>/archive/', views.AdresseArchiveView.as_view(), name='transport-address-archive'),
    path('adresse/autocomplete/', views.AdresseAutocompleteView.as_view(), name='adresse-autocomplete'),
    path('searchch/autocomplete/', views.SearchChAutocompleteView.as_view(), name='searchch-autocomplete'),

    path('chauffeurs/<int:pk>/transports/', views.ChauffeurTransportsView.as_view(), name='benevole-transports'),
    path('chauffeurs/<int:pk>/transports/pdf/', views.ChauffeurTransportsPDFView.as_view(),
        name='benevole-transports-pdf'),
    path('chauffeurs/<int:pk>/transports/archives/', views.ChauffeurTransportsView.as_view(passes=True),
        name='benevole-transports-archives'),
    path('chauffeurs/<int:pk>/transports/<int:year>/<int:month>/rembpdf/', views.ChauffeurRembPDFView.as_view(),
        name='benevole-transports-rembpdf'),
    path('chauffeurs/<int:pk>/dispo/<int:transport_pk>/', views.ChauffeurDayView.as_view(),
         name='benevole-dispo-transport'),
    path('chauffeurs/<int:pk>/dispo/<int:transport_pk>/<int:moddate>/', views.ChauffeurDayView.as_view(),
         name='benevole-dispo-transport-model'),
    path('chauffeurs/<int:pk>/agenda/<int:year>/<int:week>/', views.ChauffeurAgendaView.as_view(),
        name='benevole-agenda'),
    path('chauffeurs/<int:chauffeur_pk>/new/dispo/',
        views.ChauffeurDispoEditView.as_view(is_create=True, categ='dispo'),
        name='benevole-dispo-add'),
    path('chauffeurs/<int:chauffeur_pk>/new/absence/',
        views.ChauffeurDispoEditView.as_view(is_create=True, categ='absence'),
        name='benevole-absence-add'),
    path('dispo/<int:pk>/edit/', views.ChauffeurDispoEditView.as_view(is_create=False), name='benevole-dispo-edit'),
    path('dispo/<int:pk>/toggle/', views.ChauffeurDispoToggleView.as_view(), name='benevole-dispo-toggle'),
    path('dispo/<int:pk>/delete/', views.ChauffeurDispoDeleteView.as_view(), name='benevole-dispo-delete'),

    path('finances/', views.FinancesHomeView.as_view(), name='finances'),
    path('finances/defraiements/', views.DefraiementView.as_view(), name='defraiements'),
    path('chauffeurs/defrayer/<int:year>/<int:month>/',
        never_cache(views.ChauffeursDefraiementExportView.as_view()),
        name='defrayer-chauffeurs'),
    path('facturer/', views.TransportFactureView.as_view(), name='facturer-transports'),
    path('facture/<int:fact_pk>/facturer/', views.TransportFactureView.as_view(),
        name='client-editer-facture'),
    path('compta/export/<int:year>/<int:month>/', views.ComptaExportView.as_view(), name='exporter-compta'),
    path('facture/<int:fact_pk>/compta/export/', views.ComptaExportView.as_view(),
        name='client-exporter-compta'),
    path('finances/factures_du_mois/<int:year>/<int:month>/', views.FacturesDuMois.as_view(),
        name='factures-du-mois'),

    # paths pour app bénévoles (sous app/ car exempté 2FA)
    path('app/', views_app.HomeBenevoleView.as_view(), name='home-app'),
    path('app/dispos/', views_app.HomeBenevoleView.as_view(tab='dispos'), name='home-app-dispos'),
    path('app/manifest.json',
        cache_page(3600 * 24)(ManifestView.as_view(template_name="transport/manifest.json")),
        name='manifest'),
    path('app/chauffeur/dispos/', views_app.BenevoleDisposView.as_view(), name='benevole-self-dispos'),
    path('app/chauffeur/dispos/new/dispo/',
        views.ChauffeurDispoEditView.as_view(is_create=True, categ='dispo'),
        name='benevole-self-dispo-add'),
    path('app/chauffeur/dispos/new/absence/',
        views.ChauffeurDispoEditView.as_view(is_create=True, categ='absence'),
        name='benevole-self-absence-add'),
    path('app/chauffeur/dispos/<int:pk>/', views.ChauffeurDispoEditView.as_view(is_create=False),
        name='benevole-self-dispo-edit'),
    path('app/chauffeur/dispos/<int:pk>/toggle/', views.ChauffeurDispoToggleView.as_view(),
        name='benevole-self-dispo-toggle'),
    path('app/chauffeur/dispos/<int:pk>/delete/', views.ChauffeurDispoDeleteView.as_view(),
        name='benevole-self-dispo-delete'),
    path('app/chauffeur/agenda/<int:year>/<int:month>/<int:day>/', views_app.ChauffeurAgendaDayView.as_view(),
        name='benevole-agenda-day'),
    path('app/rapport/list/', views_app.TransportRapportListView.as_view(), name='transport-rapport-list'),
    path('app/rapport/<int:pk>/', views_app.BenevoleRapportView.as_view(), name='benevole-rapport'),
    path('app/archives/', views_app.BenevoleArchivesView.as_view(), name='benevole-archives'),
    path('app/archives/<int:year>/<int:month>/', views_app.BenevoleArchivesMonthView.as_view(),
        name='benevole-archives-month'),

    # Statistiques
    path('stats/', views_stats.StatsTransportsView.as_view(), name='stats-index'),
    path('stats/ofas/', views_stats.StatsOFASTransportsView.as_view(), name='stats-ofas'),
]

if apps.is_installed('besoins'):
    urlpatterns.append(
        path('besoins/', include('besoins.urls_app'))
    )
